#!/bin/sh
. ../../config.txt
echo -e "Content-Type: text/plain\n"
if [ -z $file -o ! $CONTENT_LENGTH ];then
	echo "Invalid request."
	exit
fi
if [ -z $file_tmp ];then file_tmp=$file;fi
tmpfile="$file_tmp/`basename $0`"
exec 9>$tmpfile
flock 9
if [ $file_max -eq 0 ];then
	file_max=`df $file|awk 'NR==2{print $4}'`
	file_max=`echo $file_max*1024/2|bc`
fi
if [ $CONTENT_LENGTH -gt $file_max ];then
	echo "File size is too large."
	exit
fi
dd status=none of=$tmpfile
c=0
while read line;do
  c=`expr $c + ${#line} + 1`
  if [ $c -gt 4096 ];then break;fi
  if [ ${#line} -eq 1 ];then
    start=$c
    break
  fi
  if echo $line|grep -E '^Content-Disposition:'>/dev/null;then
    filename=`echo $line|awk 'match($0,/filename="[^"]+"/) {print substr($0,RSTART+10,RLENGTH-11)}'`
    filename=`basename $filename`
  fi
done < $tmpfile
if [ -z $filename ] || [ -z $start ];then
  echo "Can't parse form-data."
  > $tmpfile
  exit
fi
line=`tail -1 $tmpfile`
dd status=none if=$tmpfile of="$file/$filename" bs=1 skip=$start count=`expr $CONTENT_LENGTH - $start - ${#line} - 3`
> $tmpfile
